#
# COPYRIGHT (c) 2002 - 2013 SRON (R.M.van.Hees@sron.nl)
#
#   This is free software# you can redistribute it and/or modify it
#   under the terms of the GNU General Public License, version 2, as
#   published by the Free Software Foundation.
#
#   The software is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program# if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, 
#   Boston, MA  02111-1307, USA.
#
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# 
# include system dependent stuff
ifneq ($(_DEFINED_NADC_RULES),yes)
include $(TOPDIR)/config/Rules_NADC.mk
endif
export HPATH

# add additional include files, for example HDF5, netCDF4, SQL
ADD_INC += $(HDF5_INC)
ifeq ($(_WITH_SQL),yes)
ADD_INC += $(SQL_INC)
endif

ifeq ($(_WITH_NC4),yes)
OBJS	+= $(OBJS_NC)
endif

# Rules:
all:	do-it-all

ifeq (.depend,$(wildcard .depend))
include .depend
do-it-all:	progs
else
do-it-all:      depend
endif

.depend:
	$(CC) -MM -I$(INCPATH) $(ADD_INC) \
		$(subst .o,.c,$(OBJS)) $(addsuffix .c,$(PROGS)) > .depend

depend dep:	.depend

progs:	$(PROGS)

options:
	@echo "$(CC) $(LDFLAGS) $(LLIBS)"

installdirs:
	$(MKDIR) $(BINDIR)

install:	depend progs installdirs
	$(INSTALL) $(PROGS) $(BINDIR)

.PHONY:	clean
clean:
	$(RM) $(PROGS) $(addsuffix .o,$(PROGS)) $(OBJS)

.PHONY:	realclean
realclean:	clean
	$(RM) .depend
	$(RM) *~

.PHONY:	distclean
distclean:	realclean
	(cd $(BINDIR); $(RM) $(PROGS))

#+++++++++++++++++++++++++ RULES:
.SUFFIXES:
.SUFFIXES: .o .c .f .for .cc
.c.o:
	$(CC) -c $(CFLAGS) -I$(INCPATH) $(ADD_INC) -o $@ $<
.cc.o:
	$(CXX) -c $(CXXFLAGS) -I$(INCPATH) $(ADD_INC) -o $@ $<
.for.o:
	$(F77) -c $(FFLAGS) -I$(INCPATH) $(ADD_INC) -o $@ $<
.f.o:
	$(F77) -c $(FFLAGS) -I$(INCPATH) $(ADD_INC) -o $@ $<
