/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.COPYRIGHT (c) 2008 - 2013 SRON (R.M.van.Hees@sron.nl)

   This is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License, version 2, as
   published by the Free Software Foundation.

   The software is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA  02111-1307, USA.

.IDENTifer   PROTO_MERIS
.AUTHOR      R.M. van Hees 
.KEYWORDS    header file
.LANGUAGE    ANSI-C
.PURPOSE     prototypes of MERIS modules
.ENVIRONment none
.VERSION     1.0     18-Sep-2008   Creation by R.M. van Hees
------------------------------------------------------------*/

#ifndef  NADC_PROTO_MER_                           /* Avoid redefinitions */
#define  NADC_PROTO_MER_

extern void MERISget_Version( /*@out@*/ unsigned int *, 
			      /*@out@*/ unsigned int *, 
			      /*@out@*/ unsigned int *, 
			      /*@out@*/ char * );

#if defined _STDIO_INCLUDED || defined _STDIO_H || defined __STDIO_H__
extern void MERISshow_Version( FILE *stream, const char * )
     /*@modifies stream@*/;

extern void MERIS_RD_SPH( FILE *fp, const struct mph_envi,
			  /*@out@*/ struct sph_meris *sph )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *sph@*/;

extern unsigned int MERIS_RD_TIE( FILE *, unsigned int, 
				  const struct dsd_envi *, 
				  /*@out@*/ struct tie_meris **tie )
       /*@globals  errno;@*/
       /*@modifies errno, fp, tie@*/;

extern unsigned int MERIS_RR2_RD_SQADS( FILE *fp, unsigned int, 
					const struct dsd_envi *, 
					/*@out@*/ struct sqads2_meris **sqads )
       /*@globals  errno;@*/
       /*@modifies errno, fp@*/;

extern unsigned int MERIS_RR2_RD_SFGI( FILE *fp, unsigned int, 
				       const struct dsd_envi *, 
				       /*@out@*/ struct sfgi_meris *sfgi )
       /*@globals  errno;@*/
       /*@modifies errno, fp, sfgi@*/;

extern unsigned int MERIS_RR2_RD_MDS_13( int, FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_13_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
extern unsigned int MERIS_RR2_RD_MDS_14( FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_14_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
extern unsigned int MERIS_RR2_RD_MDS_15( FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_15_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
extern unsigned int MERIS_RR2_RD_MDS_16( FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_16_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
extern unsigned int MERIS_RR2_RD_MDS_17( FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_17_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
extern unsigned int MERIS_RR2_RD_MDS_18( FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_18_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
extern unsigned int MERIS_RR2_RD_MDS_19( FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_19_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
extern unsigned int MERIS_RR2_RD_MDS_20( FILE *, unsigned int, 
					 const struct dsd_envi *, /*@out@*/ 
					 struct mds_rr2_20_meris **mds )
       /*@globals  errno;@*/
       /*@modifies errno, fp, mds@*/;
#endif   /* ---- defined _STDIO_INCLUDED || defined _STDIO_H ----- */

extern void MERIS_WR_ASCII_SPH( struct param_record, 
				const struct sph_meris * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;

extern void MERIS_WR_ASCII_TIE( struct param_record, unsigned int,
				const struct tie_meris * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;

#endif /* NADC_PROTO_MER_ */
