/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.COPYRIGHT (c) 2003 - 2013 SRON (R.M.van.Hees@sron.nl)

   This is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License, version 2, as
   published by the Free Software Foundation.

   The software is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA  02111-1307, USA.

.IDENTifer   PROTO_SCIA_LV2
.AUTHOR      R.M. van Hees 
.KEYWORDS    header file
.LANGUAGE    ANSI-C
.PURPOSE     prototypes of the specific SCIA level 2 modules
.ENVIRONment none
.VERSION     2.0     01-Nov-2001   moved to new Error handling routines, RvH
             1.0     13-Aug-2001   Creation by R.M. van Hees
------------------------------------------------------------*/

#ifndef  NADC_PROTO_SCIA_LV2                       /* Avoid redefinitions */
#define  NADC_PROTO_SCIA_LV2

#if defined _STDIO_INCLUDED || defined _STDIO_H || defined __STDIO_H__
extern void SCIA_LV2_RD_SPH( FILE *fp, const struct mph_envi,
			     /*@out@*/ struct sph2_scia *sph )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *sph@*/;
extern void SCIA_OL2_RD_SPH( FILE *fp, const struct mph_envi,
			     /*@out@*/ struct sph_sci_ol *sph )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *sph@*/;
extern void SCIA_OL2_WR_SPH( FILE *fp, const struct mph_envi,
			     /*@out@*/ struct sph_sci_ol sph )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp@*/;
extern unsigned int SCIA_LV2_RD_SQADS( FILE *fp, unsigned int,
				       const struct dsd_envi *,
				       /*@out@*/ struct sqads2_scia **sqads )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *sqads@*/;
extern unsigned int SCIA_OL2_RD_SQADS( FILE *fp, unsigned int,
				       const struct dsd_envi *,
				       /*@out@*/ struct sqads_sci_ol **sqads )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *sqads@*/;
extern unsigned int SCIA_LV2_RD_STATE( FILE *fp, unsigned int,
				       const struct dsd_envi *,
				       /*@out@*/ struct state2_scia **state )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *state@*/;
extern unsigned int SCIA_LV2_RD_GEO( FILE *fp, unsigned int,
				     const struct dsd_envi *,
				     /*@out@*/ struct geo_scia **geo )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *geo@*/;
extern unsigned int SCIA_OL2_RD_NGEO( FILE *fp, unsigned int,
				      const struct dsd_envi *,
				      /*@out@*/ struct ngeo_scia **geo )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *geo@*/;
extern unsigned int SCIA_OL2_RD_LGEO( FILE *fp, unsigned int,
				      const struct dsd_envi *,
				      /*@out@*/ struct lgeo_scia **geo )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *geo@*/;
extern unsigned int SCIA_LV2_RD_CLD( FILE *fp, unsigned int,
				     const struct dsd_envi *,
				     /*@out@*/ struct cld_scia **cld )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *cld@*/;
extern unsigned int SCIA_OL2_RD_CLD( FILE *fp, unsigned int,
				     const struct dsd_envi *,
				     /*@out@*/ struct cld_sci_ol **cld )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *cld@*/;
extern unsigned int SCIA_LV2_RD_DOAS( FILE *fp, const char *, unsigned int,
				      const struct dsd_envi *,
				      /*@out@*/ struct doas_scia **doas )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *doas@*/;
extern unsigned int SCIA_LV2_RD_BIAS( FILE *fp, const char *, unsigned int,
				      const struct dsd_envi *,
				      /*@out@*/ struct bias_scia **bias )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *bias@*/;
extern unsigned int SCIA_OL2_RD_NFIT( FILE *fp, const char *, unsigned int,
				      const struct dsd_envi *,
				      /*@out@*/ struct nfit_scia **nfit )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *nfit@*/;
extern unsigned int SCIA_OL2_RD_LFIT( FILE *fp, const char *, unsigned int,
				      const struct dsd_envi *,
				      /*@out@*/ struct lfit_scia **lfit )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *lfit@*/;
extern unsigned int SCIA_OL2_RD_LCLD( FILE *fp, unsigned int,
				      const struct dsd_envi *,
				      /*@out@*/ struct lcld_scia **lcld )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack, fp, *lcld@*/;
#endif   /* ---- defined _STDIO_INCLUDED || defined _STDIO_H ----- */

extern void SCIA_LV2_WR_ASCII_SPH( struct param_record, 
				   const struct sph2_scia  * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_LV2_WR_ASCII_SQADS( struct param_record, unsigned int,
				     const struct sqads2_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_LV2_WR_ASCII_STATE( struct param_record, unsigned int,
				     const struct state2_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_LV2_WR_ASCII_GEO( struct param_record, unsigned int,
				   const struct geo_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_LV2_WR_ASCII_CLD( struct param_record, unsigned int,
				   const struct cld_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_LV2_WR_ASCII_DOAS( const char mds_name[],
				    struct param_record, unsigned int,
				    const struct doas_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_LV2_WR_ASCII_BIAS( const char mds_name[],
				    struct param_record, unsigned int,
				    const struct bias_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;

extern void SCIA_OL2_WR_ASCII_SPH( struct param_record, 
				   const struct sph_sci_ol  * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_OL2_WR_ASCII_SQADS( struct param_record, unsigned int,
				     const struct sqads_sci_ol * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_OL2_WR_ASCII_NGEO( struct param_record, unsigned int,
				   const struct ngeo_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_OL2_WR_ASCII_LGEO( struct param_record, unsigned int,
				   const struct lgeo_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_OL2_WR_ASCII_CLD( struct param_record, unsigned int,
				   const struct cld_sci_ol * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_OL2_WR_ASCII_NFIT( const char mds_name[],
				    struct param_record, unsigned int,
				    const struct nfit_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_OL2_WR_ASCII_LFIT( const char mds_name[],
				    struct param_record, unsigned int,
				    const struct lfit_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;
extern void SCIA_OL2_WR_ASCII_LCLD( struct param_record, unsigned int,
				    const struct lcld_scia * )
       /*@globals  errno, nadc_stat, nadc_err_stack;@*/
       /*@modifies errno, nadc_stat, nadc_err_stack@*/;

#ifdef _HDF5_H
extern void CRE_SCIA_LV2_H5_STRUCTS( struct param_record );
extern void CRE_SCIA_OL2_H5_STRUCTS( struct param_record );
extern void SCIA_LV2_WR_H5_SPH( struct param_record, 
				const struct sph2_scia * );
extern void SCIA_OL2_WR_H5_SPH( struct param_record, 
				const struct sph_sci_ol * );
extern void SCIA_LV2_WR_H5_SQADS( struct param_record, unsigned int,
				  const struct sqads2_scia * );
extern void SCIA_OL2_WR_H5_SQADS( struct param_record, unsigned int,
				  const struct sqads_sci_ol * );
extern void SCIA_LV2_WR_H5_STATE( struct param_record, unsigned int,
				  const struct state2_scia * );
extern void SCIA_LV2_WR_H5_GEO( struct param_record, unsigned int,
				const struct geo_scia * );
extern void SCIA_OL2_WR_H5_NGEO( struct param_record, unsigned int,
				 const struct ngeo_scia * );
extern void SCIA_OL2_WR_H5_LGEO( struct param_record, unsigned int,
				 const struct lgeo_scia * );
extern void SCIA_LV2_WR_H5_CLD( struct param_record, unsigned int,
				const struct cld_scia * );
extern void SCIA_OL2_WR_H5_CLD( struct param_record, unsigned int,
				const struct cld_sci_ol * );
extern void SCIA_LV2_WR_H5_DOAS( const char *, struct param_record, 
				 unsigned int, const struct doas_scia * );
extern void SCIA_LV2_WR_H5_BIAS( const char *, struct param_record, 
				 unsigned int, const struct bias_scia * );
extern void SCIA_OL2_WR_H5_NFIT( const char *, struct param_record, 
				 unsigned int, const struct nfit_scia * );
extern void SCIA_OL2_WR_H5_LFIT( const char *, struct param_record, 
				 unsigned int, const struct lfit_scia * );
extern void SCIA_OL2_WR_H5_LCLD( struct param_record, 
				 unsigned int, const struct lcld_scia * );
#endif /* _HDF5_H */

#endif /* NADC_PROTO_SCIA_LV2 */
