#!/usr/bin/env python2.4
#
#
import glob
import sys
import string
import os
import os.path

from commands import getstatusoutput

PATH_SCIA_LV0 = [ '/SCIA/LV0_01', '/SCIA/LV0_02', '/SCIA/LV0_03',
                  '/SCIA/LV0_04', '/SCIA/LV0_05' ]
    
PATH_SCIA_LV1 = [ '/SCIA/LV1_01', '/SCIA/LV1_02', '/SCIA/LV1_03',
                  '/SCIA/LV1_04', '/SCIA/LV1_05', '/SCIA/LV1_06',
                  '/SCIA/LV1_07', '/SCIA/LV1_08', '/SCIA/LV1_09',
                  '/SCIA/LV1_10' ]

PATH_SCIA_LV2 = [ '/SCIA/OL2_01/2002', '/SCIA/OL2_01/2003',
                  '/SCIA/OL2_01/2004', '/SCIA/OL2_01/2005',
                  '/SCIA/OL2_01/2006', '/SCIA/OL2_01/2007' ]

PATH_GOME_LV1 = [ '/GOME/LV1_01/1995',
                  '/GOME/LV1_01/1996', '/GOME/LV1_01/1997',
                  '/GOME/LV1_01/1998', '/GOME/LV1_01/1999',
                  '/GOME/LV1_01/2000', '/GOME/LV1_01/2001',
                  '/GOME/LV1_01/2002', '/GOME/LV1_01/2003',
                  '/GOME/LV1_01/2004', '/GOME/LV1_01/2005',
                  '/GOME/LV1_01/2006', '/GOME/LV1_01/2007' ]
    
PATH_GOME_LV2 = [ '/GOME/LV2_01/1995',
                  '/GOME/LV2_01/1996', '/GOME/LV2_01/1997',
                  '/GOME/LV2_01/1998', '/GOME/LV2_01/1999',
                  '/GOME/LV2_01/2000', '/GOME/LV2_01/2001',
                  '/GOME/LV2_01/2002', '/GOME/LV2_01/2003',
                  '/GOME/LV2_01/2004', '/GOME/LV2_01/2005',
                  '/GOME/LV2_01/2006', '/GOME/LV2_01/2007' ]

PATH_GOME_FRESCO = [ '/GOME/share/Fresco' ]

PATH_SCIA_FRESCO = [ '/SCIA/share/Fresco' ]

def check_db_presence( file_path ):
    cmd = "mysql -h localhost -u nadc_user --silent --disable-column-names "
    flname = os.path.basename( file_path )
    if flname[-3:] == ".gz": flname = flname[:-3]
    
    if flname[-3:] == "lv1":
        cmd += "--execute=\'select COUNT(*) from gome.meta__1P where pk_name="
        cmd += "\"" + flname + "\"\'"
        stat = getstatusoutput( cmd )
        return stat[1]
    elif flname[-3:] == "lv2":
        cmd += "--execute=\'select COUNT(*) from gome.meta__2P where pk_name="
        cmd += "\"" + flname + "\"\'"
        stat = getstatusoutput( cmd )
        return stat[1]
    elif flname[:10] == "SCI_NL__0P":
        cmd += "--execute=\'select COUNT(*) from scia.meta__0P where pk_name="
        cmd += "\"" + flname + "\"\'"
        stat = getstatusoutput( cmd )
        return stat[1]
    elif flname[:10] == "SCI_NL__1P":
        cmd += "--execute=\'select COUNT(*) from scia.meta__1P where pk_name="
        cmd += "\"" + flname + "\"\'"
        stat = getstatusoutput( cmd )
        return stat[1]
    elif flname[:10] == "SCI_OL__2P":
        cmd += "--execute=\'select COUNT(*) from scia.meta__2P where pk_name="
        cmd += "\"" + flname + "\"\'"
        stat = getstatusoutput( cmd )
        return stat[1]

    print "Fatal: unexpected filetype " + flname[:10]
    return "1"

def loop_through_dirs( dir_lst, prognm ):
    tmppath = '/dev/shm'
    for base_dir in dir_lst:
        prod_lst = glob.glob( base_dir + '/*' )
        for prod_dir in prod_lst:
            file_lst = glob.glob( prod_dir + '/SCI_*' )
            for file_path in file_lst:
                print file_path
                if file_path[-3:] == '.gz':
                    pathnm = os.path.dirname( file_path )
                    file_tmp = tmppath + '/' + os.path.basename(file_path[:-3])
                    stat = getstatusoutput( 'zcat ' + file_path \
                                            + ' > ' + file_tmp )
                    if stat[0] != 0:
                        print stat[1]
                        print 'FATAL error occured while unzipping product ' \
                              + file_path
                    stat = getstatusoutput( prognm + file_tmp )
                    os.remove( file_tmp )
                    print stat[1]
                    if stat[0] != 0:
                        print 'FATAL: failed to ingest ' + file_path
                else:
                    stat = getstatusoutput( prognm + file_path )
                    print stat[1]
                    if stat[0] != 0:
                        print 'FATAL: failed to ingest ' + file_path

def loop2_through_dirs( dir_lst, prognm ):
    for year_dir in dir_lst:
        month_lst = glob.glob( year_dir + '/??' )
        for month_dir in month_lst:
            day_lst = glob.glob( month_dir + '/??' )
            for day_dir in day_lst:
                file_lst = glob.glob( day_dir + '/*.lv?' )
                if len(file_lst) == 0:
                    file_lst = glob.glob( day_dir + '/SCI_*' )
                for file_path in file_lst:
                    print file_path
                    stat = getstatusoutput( prognm + file_path )
                    if stat[0] != 0:
                        print stat[1]
                        print 'FATAL: failed to ingest ' + file_path

def loop3_through_dirs( dir_lst, prognm ):
    tmppath = '/dev/shm'
    for base_dir in dir_lst:
        year_lst = glob.glob( base_dir + '/????' )
        for year_dir in year_lst:
            file_lst = glob.glob( year_dir + '/*.dat.gz' )
            for file_path in file_lst:
                print file_path
                if file_path[-3:] == '.gz':
                    pathnm = os.path.dirname( file_path )
                    file_tmp = tmppath + '/' + os.path.basename(file_path[:-3])
                    stat = getstatusoutput( 'zcat ' + file_path \
                                            + ' > ' + file_tmp )
                    if stat[0] != 0:
                        print stat[1]
                        print 'FATAL error occured while unzipping product ' \
                              + file_path
                    stat = getstatusoutput( prognm + file_tmp )
                    os.remove( file_tmp )
                    if stat[0] != 0:
                        print stat[1]
                        print 'FATAL: failed to ingest ' + file_path
                else:
                    stat = getstatusoutput( prognm + file_path )
                    if stat[0] != 0:
                        print stat[1]
                        print 'FATAL: failed to ingest ' + file_path
                    
#+++++++++++++++++++++++++
if __name__ == '__main__':
    if len(sys.argv) == 1:
        print 'Usage: ' + sys.argv[0] + ' <g1|g2|s0|s1|s2>'
        sys.exit(1)

    if sys.argv[1] == 'g1':
        loop2_through_dirs( PATH_GOME_LV1, 'gome_lv1 -sql ' )
    elif sys.argv[1] == 'g2':
        loop2_through_dirs( PATH_GOME_LV2, 'gome_lv2 -sql ' )
    elif sys.argv[1] == 's0':
        loop_through_dirs( PATH_SCIA_LV0, 'scia_nl0 -sql ' )
    elif sys.argv[1] == 's1':
        loop_through_dirs( PATH_SCIA_LV1, 'scia_nl1 -sql ' )
    elif sys.argv[1] == 's2':
        loop2_through_dirs( PATH_SCIA_LV2, 'scia_ol2 -sql ' )
    elif sys.argv[1] == 'gf':
        loop3_through_dirs( PATH_GOME_FRESCO, 'nadc_fresco gome ' )
    elif sys.argv[1] == 'sf':
        loop3_through_dirs( PATH_SCIA_FRESCO, 'nadc_fresco scia ' )
    else:
        print 'Usage: ' + sys.argv[0] + ' <g1|g2|s0|s1|s2|gf|sf>'
        sys.exit(1)
    sys.exit(0)
