#!/bin/bash
#
LANG="en_US"

if [ $# -lt 3 ]
then
    echo "Usage $0 filename flag_maj[0|1] comment"
    exit 1
else
    file_in=$1
    flag_maj=$2
    comment=$3
fi

TMPFILE=`mktemp /tmp/$1.XXXXXX` || exit 1
mv $file_in $TMPFILE

awk '{ if ( $1 == ".VERSION" ) {
	    if ( vers_maj != 0 )
		newversion = $2 + 0.1
	    else
		newversion = int($2) + 1
	    printf ".VERSION     %4.1f%14s\t%s\n", 
		    newversion, newdate, comment
	    printf "%13s%4.1f%14s\t", " ", $2, $3
	    for ( ii = 4; ii <= NF; ii++ ) printf "%s ", $ii
	    printf "\n"
	} else {
	    print $0
	} 
    }' newdate=$(date +%d-%b-%Y) vers_maj=$flag_maj comment="$comment" \
	$TMPFILE > $file_in

rm -f $TMPFILE
